#include <iostream>
#include <cmath>
#include <fstream>
#include <string>
#include <vector>

using namespace std;

ofstream debuglog;

// ios binary means DON'T try and fix unix line endings / etc.

// technically all bytes
float find_magnitude(float ir, float ig, float ib)
{

    float tTemp1 = ir*ir + ig*ig + ib*ib;
    cout << tTemp1 << endl;
    float tTemp2 = sqrt(tTemp1);
    cout << tTemp2 << endl;
    return tTemp2;
}

struct RGB
{
    unsigned char R;
    unsigned char G;
    unsigned char B;
};

struct Pal
{
    RGB Colors[256];
};

struct PLAYPAL
{
    Pal Palettes[14];
};

// add file open error
PLAYPAL ReadPaletteFile(string iFileName)
{
    PLAYPAL tPal;
    ifstream infile;
    infile.open(iFileName.c_str(), ios::binary);
    if(!infile)
    {
        cout << "Error: Could not read " << iFileName << endl;
    }
    infile.read((char*)&tPal, sizeof(PLAYPAL));
    cout << "sizeof(PLAYPAL) is " << sizeof(PLAYPAL) << endl;

    return tPal;
}

bool WritePaletteFile(PLAYPAL iPal, string iFileName)
{
    ofstream tempfile;
    tempfile.open(iFileName.c_str(), ios::binary);
    if(!tempfile)
    {
        return false;
    }

    tempfile.write((char*)&iPal,sizeof(PLAYPAL));
    return true;
}

struct COLORMAP
{
    unsigned char indexes[256];
};

struct COLORMAP_File
{
    COLORMAP Maps[34];
};

bool WriteCOLORMAPFile(COLORMAP_File iCM, string iFileName)
{
    ofstream tempfile;
    tempfile.open(iFileName.c_str(), ios::binary);
    if(!tempfile)
    {
        return false;
    }

    tempfile.write((char*)&iCM,sizeof(COLORMAP_File));
    return true;
}


COLORMAP filldummyindex()
{
    COLORMAP tdummyindex;
    for(int i = 0; i < 256; i++)
    {
        tdummyindex.indexes[i] = i;
    }

    return tdummyindex;
}

float min3(float a, float b, float c)
{
    float t1 = min(a,b);
    float t2 = min(b,c);
    return min(t1,t2);
}

float max3(float a, float b, float c)
{
    float t1 = max(a,b);
    float t2 = max(b,c);
    return max(t1,t2);
}

struct HSV
{
    float H;
    float S;
    float V;
};

struct HSV_Pal
{
    HSV Colors[256];
};

// potential member function of a COLOR class? Convert to HSV?

// code based on http://www.cs.rit.edu/~ncs/color/t_convert.html
HSV RGBtoHSV(RGB iRGB)
{
	float tmin, tmax, delta;
	HSV tHSV;

	tmin = min3( iRGB.R, iRGB.G, iRGB.B );
	tmax = max3( iRGB.R, iRGB.G, iRGB.B );
	tHSV.V = tmax;
	// value is the maximum of r,g, and b, it is brightness

	delta = tmax - tmin;

	if( tmax != 0 )
		tHSV.S = delta / tmax;		// s

	else
    {
		// r = g = b = 0		// s = 0, v is undefined
		tHSV.S = 0;
		tHSV.H = -1;
		return tHSV;
	}

	if( iRGB.R == tmax )
		tHSV.H = ( iRGB.G - iRGB.B ) / delta;		// between yellow & magenta
	else if( iRGB.G == tmax )
		tHSV.H = 2 + ( iRGB.B - iRGB.R ) / delta;	// between cyan & yellow
	else
		tHSV.H = 4 + ( iRGB.R - iRGB.G ) / delta;	// between magenta & cyan

	tHSV.H *= 60;				// degrees
	if( tHSV.H < 0 )
		tHSV.H += 360;

    return tHSV;

}

    typedef vector<RGB> SearchResults;

void PrintHSV(HSV iHSV)
{
    cout << "H is " << iHSV.H << endl;
    cout << "S is " << iHSV.S << endl;
    cout << "V is " << iHSV.V << endl;
    return;
}

void LogHSV(HSV iHSV)
{
    debuglog << "H is " << iHSV.H << endl;
    debuglog  << "S is " << iHSV.S << endl;
    debuglog  << "V is " << iHSV.V << endl;
    return;
}

void PrintRGB(RGB iRGB)
{
    cout << "R is " << (int) iRGB.R << endl;
    cout << "G is " << (int) iRGB.G << endl;
    cout << "B is " << (int) iRGB.B << endl;
    return;
}

struct ColorMapRow
{
    int Indexes[32];
};

struct Color_Compare
{
    float Delta_H;
    float Delta_V;
    int Index;
};

ColorMapRow FindNearest32indexes(HSV_Pal Palette,HSV iColor)
{
    ColorMapRow tColorMapRow;

    debuglog << "iColor is " << endl;
    LogHSV(iColor);

    // for all 32 rows of the colormap
    for (int i = 1 ; i < 32 ; i++)
    {
        float target_V = (32-i)/32;
        Color_Compare BestMatch;
        Color_Compare CurrentColor; // current PLAYPAL color

        debuglog << "Calculating colormap index " << i << endl;

        BestMatch.Delta_H = 9999;
        BestMatch.Delta_V = 9999;

        //TODO
        //"V is 31", it doesn't run from 0 to 1 for some reason. Seems to run from 0 to 255
        // Remember that H runs from 0 to 360

        // for all 256 colors in PLAYPAL
        for(int j = 0; j < 256 ; j++)
        {
            debuglog << "j = " << j << endl;
            CurrentColor.Delta_H = abs(iColor.H - Palette.Colors[j].H);
            CurrentColor.Delta_V = abs(target_V - Palette.Colors[j].V);

            debuglog << "Colors[" << j << "].H is " << Palette.Colors[j].H << endl;
            debuglog << "Colors[" << j << "].V is " << Palette.Colors[j].V << endl;

            debuglog << "Delta_H is " << CurrentColor.Delta_H << endl;
            debuglog << "Delta_V is " << CurrentColor.Delta_V << endl;

            if((CurrentColor.Delta_H < BestMatch.Delta_H) && (CurrentColor.Delta_V < BestMatch.Delta_V))
            {
                BestMatch = CurrentColor;
                BestMatch.Index = j;
                debuglog << "Best Match updated:" << endl;
                PrintHSV(Palette.Colors[j]);
                debuglog << "Index is " << BestMatch.Index << endl;
                debuglog << "---------------" << endl;
            }
        }

    // save the best match for this row of the colormap
    tColorMapRow.Indexes[i] = BestMatch.Index;

    }

    return tColorMapRow;
}

void PrintColorMapRow(ColorMapRow iColorMapRow)
{
    for(int i = 0; i < 32; i++)
    {
        cout << "Colormaprow[" << i << "] == " << iColorMapRow.Indexes[i] << endl;
    }

    return;
}


SearchResults SearchPalette(Pal iPalette, float Hfuzz, float Vfuzz)
{
    SearchResults tSearchResults;

    HSV_Pal tHSV_Pal;

    for(int i = 0; i < 256; i++)
    {
        RGB tcolor;
        tcolor = iPalette.Colors[i];
        tHSV_Pal.Colors[i] = RGBtoHSV(tcolor);
    }

    cout << "Color sample: See how HSV changes" << endl;
    for(int i = 160; i < 176; i++)
    {
        cout << "Entry " << i << endl;
        PrintRGB(iPalette.Colors[i]);
        cout << "-----------" << endl;
        PrintHSV(tHSV_Pal.Colors[i]);
        cout << endl;
    }


    ColorMapRow tColormaprow;
    tColormaprow = FindNearest32indexes(tHSV_Pal,tHSV_Pal.Colors[16]);
    PrintColorMapRow(tColormaprow);



    // writing dummy value to vector
    RGB tColor = iPalette.Colors[1];
    tSearchResults.push_back(tColor);

    return tSearchResults;

}

// find the closest 32 matches in decreasing variance and close hue

int main()
{

    debuglog.open("log.txt");

    PLAYPAL tPal;
    tPal = ReadPaletteFile("C:\\PAL\\PLAYPAL.pal");
    WritePaletteFile(tPal, "output.pal");

    unsigned char tTest = 0x40;
    cout << "tTest is " << (int) tTest << endl;

    SearchResults tSearchResults;
    tSearchResults = SearchPalette(tPal.Palettes[0],0,0);


    COLORMAP_File tColormap_file;
    COLORMAP tColormap_dummy = filldummyindex();

    for(int i = 0; i < 34; i++)
    {
        tColormap_file.Maps[i] = tColormap_dummy;
    }

    WriteCOLORMAPFile(tColormap_file,"Colormaptest.cm");





    return 0;
}
